signal_connection
	var
		m_signal
		m_destination
		m_slot

	New(signal, destination, slot)
		ASSERT(signal)
		ASSERT(destination)
		ASSERT(slot)

		m_signal = signal
		m_destination = destination
		m_slot = slot

	proc
		equals(signal_connection/C)
			return (m_signal == C.m_signal && \
				m_destination == C.m_destination && \
				m_slot == C.m_slot)

		emit(arguments)
			if(m_destination)
				call(m_destination, m_slot)(arglist(arguments))
				return 1
			else return 0

		match(signal)
			return (m_signal == signal)